#!/usr/bin/perl

use strict;
use warnings;

use File::stat;
use Win32::DriveInfo;
use File::Copy;

# Ϣ(for Sony Cybershot T-10)
my $root = 'DCIM';						# ƬĸĿ¼
my $folder_pattern = '^\d+MSDCF$';		# ƬĿ¼ĸʽ
my $dest = "D:/myphoto";				# ƬƵĿĵ

# ȡUSB豸̷
sub get_usb_drive {

    my @usb_drives =
      ( grep { Win32::DriveInfo::DriveType($_) == 2 }
          Win32::DriveInfo::DrivesInUse() );

	return @usb_drives;
}

# ȡU
my @drives = get_usb_drive();

# UƬĿ¼
my @folder_list = ();
foreach my $drive (@drives) {
	my $root_path = "$drive:/$root";

	# ҵĿ¼еƬĿ¼
	if (-d $root_path) {

		chdir $root_path;
		my @folders = <*>;

		foreach my $folder (@folders) {
			if ($folder =~ /$folder_pattern/ and -d $folder) {
				push @folder_list, "$root_path/$folder";
			}
		}
	}
}

# Ƭ
foreach my $folder (@folder_list) {
	chdir $folder;
	my @files = <*>;

	foreach my $file (@files) {
		# ȡƬ޸ʱ
		my $st = stat($file);
		my ($day, $month, $year) = (localtime($st->mtime))[3..5];
		$year += 1900; $month++;

		# ޸ʱĿĵ
		my $dest_folder = sprintf("%04d%02d%02d", $year, $month, $day);
		$dest_folder = "$dest/$dest_folder";
		if (!-d $dest_folder) {
			mkdir $dest_folder;
		}

		# ļ
		copy $file, $dest_folder;
		print "$folder/$file --> $dest_folder\n";
	}
}

system('pause');
